#!/usr/bin/perl
# fixup-removeblankunits.pl
#                   RBLandau 20071009
#
use English; 
use newtrace;
use strict; 

my $sPrefix = "pdm";

defined($ARGV[1-1]) || die "Usage: fixup  mib-file\n";

# Now the MIB file
my $sMibFile = $ARGV[1-1];
newtrace::trace( 1,"file1|$sMibFile|");
open( MIB,  '<', $sMibFile ) || die "Error: cannot open input file $sMibFile: $!";

my $sLine1 = "";
my $sLine2 = "";
my $sLine3 = "";
my $fLine1empty = 1;
my $fLine2empty = 1;
my $fLine3empty = 1;

# Process the MIB file line by line.
# Look for triplets of lines: SYNTAX, blank, MAX-ACCESS.
# Eliminate the blank. 
while (<MIB>)
{
    # three-line silo
    if ( !$fLine2empty )
    {
        $sLine1 = $sLine2;
        $fLine1empty = 0;
    }
    if ( !$fLine3empty )
    {
        $sLine2 = $sLine3;
        $fLine2empty = 0;
    }
    $sLine3 = $_;
    $fLine3empty = 0;

    my $fLine2blank = 0;
    my $fLine1Found = 0;
    my $fLine3Found = 0;
    $fLine2blank = $sLine2 =~ /^\s*$/;
    $fLine1Found = $sLine1 =~ /^\s*SYNTAX\s/;
    $fLine3Found = $sLine3 =~ /^\s*MAX-ACCESS\s/;
    my $sLine1TEMP = $sLine1;
    chomp $sLine1TEMP;
    $sLine1TEMP =~ s/\r//g;
    newtrace::trace(3,"");
    newtrace::trace(3,"proc line $NR line1=|$sLine1TEMP|");
    newtrace::trace(3,"proc line $NR bools|$fLine1Found|$fLine2blank|$fLine3Found|");
    if ( $fLine1Found && $fLine3Found && $fLine2blank )
    {
        $fLine2empty = 1;
        newtrace::trace(1,"proc blank unit line at $NR");
    }

    # Print the line falling off the end of the silo, 
    # if there is one.  Print it only once.
    if ( !$fLine1empty )
    {
        print $sLine1 ;
        $fLine1empty = 1; 
    }

}
    # And output the stragglers. 
    print $sLine1 if ( !$fLine1empty );
    print $sLine2 if ( !$fLine2empty );
    print $sLine3 if ( !$fLine3empty );

#end
