#!/usr/bin/perl
# fixup-removeduplicateoids.pl
#                   RBLandau 20071008
#
use English; 
use newtrace;

my $sPrefix = "pdm";

defined($ARGV[1-1]) || die "Usage: fixup  mib-file\n";

# Now the MIB file
$sMibFile = $ARGV[1-1];
newtrace::trace( 1,"file1|$sMibFile|");
open( MIB,  '<', $sMibFile ) || die "Error: cannot open input file $sMibFile: $!";
newtrace::trace(3,"");

my %hGroup2Number;
# Process the MIB file line by line.
# For all lines that appear to be assigning a group number, 
#  check to see if the number has already been used.
#  If it has, don't print the line.  
while (<MIB>)
{
    $sLine = $_;
    $sOidName = "";
    ($sOidName,$sOidRoot,$sOidNum) = $sLine =~
/\s*([-a-zA-Z0-9]+)\s+OBJECT\s+IDENTIFIER\s+::=\s+{\s*([-a-zA-Z0-9])+\s+(\d+)\s*}/;
    if ( $sOidName )
    {
        $sGroupNum = "";
        newtrace::trace(1,"proc  oidassign to|$sOidName| num|$sOidNum|");
        if ( defined($hGroup2Number{$sOidName}) && ($sGroupNum = $hGroup2Number{$sOidName}) )
        {
            # It's a group OID assignment for a group we know.
            newtrace::trace(3,"proc oid|$sOidName| prev|$sGroupNum| now|$sOidNum|");
            if ( $sOidNum == $sGroupNum )
            {
                # It's the same number that we've seen before.  
                # Don't print the line, it's a dup.
            } else
            {
                # It's a different number, 
                # therefore an error.
                print "E R R O R : inconsistent OID assignments.\n"; 
                print "group|$sOidName| previously|$sGroupNum| now|$sOidNum|\n";
            }
        } else
        {
            # Looks like a group assignment that we haven't seen before.
            $hGroup2Number{$sOidName} = $sOidNum;
            print $sLine;
        }
        print "\n";
    }
    else
    {
        # Not a group assignment, some other statement.  
        print; 
    }
}
